# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_超发记录,32,32-15,sit,be
主数据平台:后台运营系统获取超发记录接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_32st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1_be")
password = commonFuc().get_business_data(module, "password1_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取超发记录
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url14")
request_body = commonFuc().get_business_data(module, "payload14")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
flow_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取超发记录信息
custData = result["data"]["list"][flow_random]["customerCode"]
productData = result["data"]["list"][flow_random]["productName"]
demandCode = result["data"]["list"][flow_random]["demandCode"]
distributionCode = result["data"]["list"][flow_random]["distributionCode"]
startTime = result["data"]["list"][flow_random]["createTime"][:10] + " 00:00:00"
endTime = str(datetime.datetime.now().strftime("%Y-%m-%d")) + " 00:00:00"

# 第三步进行列表查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url15")
request_body = commonFuc().get_business_data(module, "payload15", custData, productData, demandCode,
                                             distributionCode, startTime, endTime)

"""

 场景: 列表查询条件验证_超发记录
 用例名称：列表查询条件验证_超发记录
 输出：{"productData":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取超发记录信息
result = json.loads(result.content)
result = {"productData": result["data"]["list"][0]["productName"]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict15", productData)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
