# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc草稿导出验证_快速下单,33,33-40,sit,be
主数据平台:多采商城草稿导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
from common.handle_excel import HandleExcel
import requests
import json
import os

module = "cmdc_33st"

# 第一步登录多采商城获取token
username = commonFuc().get_business_data(module, "username_be")
password = commonFuc().get_business_data(module, "password_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第二步进行草稿订单创建
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url40")
request_body = commonFuc().get_business_data(module, "payload40")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取订单信息
draftDemandCode = result["data"]["draftDemandCode"]
createTime = result["data"]["createTime"]

# 第三步草稿导出操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url41")
request_body = [commonFuc().get_business_data(module, "payload41", draftDemandCode, createTime)]
print(request_body)
"""

 场景: 草稿导出验证_快速下单
 用例名称：草稿导出验证_快速下单
 输出：{"draftDemandCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# # 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/同步导出草稿.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中制单人信息
excel = HandleExcel(file_path, "工作表1")
result = {"draftDemandCode": excel.read_data()[0].get("订单编号")}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict41", draftDemandCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

