# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc电商下单时间排序功能验证_销售明细列表_升序,34,34-9,sit,be
主数据平台:后台运营系统销售明细列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import json

module = "cmdc_34st"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步按电商下单时间升序排列
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url9")
request_body = commonFuc().get_business_data(module, "payload9")

"""

 场景: 电商下单时间排序功能验证_销售明细列表_升序
 用例名称：电商下单时间排序功能验证_销售明细列表_升序
 输出：{"demandParentCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取销售明细列表
result = json.loads(result.content)
result = {"demandParentCode": result["data"]["list"][0]["demandParentCode"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db_be")

# 在数据库中按电扇下单时间升序查询对应的销售明细信息
sql = "select * from (select main.demandParentCode,subtd.sellerCompanyCode as companyCode,subtd.sellerCompanyName,subtd.demandCode,td.createTime,td.auditTime,subtd.distributionType,td.paymentType, main.paidTime,jd.SDDOCO as soCode,jd.SDTRDJ, subtd.customerCode,subtd.customerName,subsku.productCode,subsku.productName, subsku.materialCode,subsku.optionStr,subsku.manufacturer,subtd.productLineCode,subtd.productLineName,subsku.measuringUnit,subsku.sendQuantity,jd.DTTUPRC,jd.DTTAEXP,jd.SDUPRC,jd.SDAEXP, jd.IOLOT1,jd.SDLOTN,jd.FCD01,jd.IOMMEJ ,jd.SDADDJ,jd.SDDCTO ,jd.SDSOQS, jd.QWDSC, jd.SDPMPN, subsku.price, subsku.promotionPrice, (subsku.realPay/subsku.quantity) as realUnitPrice, subsku.price*jd.SDSOQS as originalTotalAmount, subsku.promotionPrice*jd.SDSOQS as rebateTotalAmount, (subsku.realPay/subsku.quantity)*jd.SDSOQS as realTotalAmount, subsku.manufacturerUserNo,subsku.manufacturerUserDesc,subsku.manufacturerProductNo,subsku.manufacturerProductDesc, if(subsku.manufacturerUserNo is not null,if(mu.id is null,1,0),0) as manufacturerUserDeleteSign, if(subsku.manufacturerProductNo is not null,if(mp.id is null,1,0),0) as manufacturerProductDeleteSign from tc_jde_580_jde jd inner join tc_demand_sub_sku subsku on jd.demandSubCode = subsku.demandSubCode and jd.SDKCOO = subsku.sellerCompanyCode and jd.SDLTTR < 980 and jd.subLineNumber = subsku.subLineNumber inner join tc_demand_sub subtd on subsku.demandSubCode = subtd.demandSubCode inner join tc_demand td on jd.demandCode = td.demandCode inner join tc_demand_main main on subsku.demandParentId = main.demandParentId left join tc_manufacturer_user mu on mu.id = subsku.manufacturerUserId left join tc_manufacturer_product mp on mp.id = subsku.manufacturerProductId where subtd.demandId is not null and subtd.sellerCompanyCode = '00102' order by td.createTime desc) tmp_count order by createTime asc"
demandParentCode = mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict9", demandParentCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
