# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_终端流向,2295,2295-61,sit,bs
主数据平台:后台运营系统获取终端流向列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取终端流向列表信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url60")
request_body = commonFuc().get_business_data(module, "payload60")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
flow_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取终端流向信息
delete_sign = result["data"]["list"][flow_random]["deleteSign"]
flow_id = result["data"]["list"][flow_random]["flowId"]
end_customer_name = result["data"]["list"][flow_random]["endCustomerName"]
invoice_no = result["data"]["list"][flow_random]["invoiceNo"]
manufacturer = result["data"]["list"][flow_random]["manufacturer"]
customer_code = result["data"]["list"][flow_random]["customerCode"]
customer_name = result["data"]["list"][flow_random]["customerName"]
demand_code = result["data"]["list"][flow_random]["demandCode"]

# 第三步获取终端流向详情信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url65")
request_body = commonFuc().get_business_data(module, "payload65", demand_code, invoice_no, delete_sign, flow_id)
# 发送请求
result1 = requests.post(url, json=request_body, headers=headers)
result1 = json.loads(result1.content)

# 获取终端流向详情信息
product_info = (result1["data"][0]["productName"] if result1["data"][0]["productName"] else "")
material_code = (result1["data"][0]["materialCode"] if result1["data"][0]["materialCode"] else "")
order_start_time = result1["data"][0]["orderTime"][:10]
upload_start_time = result1["data"][0]["orderTime"][:10]
product_code = result1["data"][0]["productCode"]
product_code = ""
now_date = datetime.datetime.now().strftime("%Y-%m-%d")

# 第四步进行列表查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url61")
request_body = commonFuc().get_business_data(module, "payload61", end_customer_name, invoice_no, manufacturer,
                                             product_info,
                                             material_code, order_start_time, customer_code, customer_name,
                                             upload_start_time,
                                             now_date, product_code, demand_code, now_date)
# print(request_body)
# print(material_code)
"""

 场景: 列表查询条件验证_终端流向
 用例名称：列表查询条件验证_终端流向
 输出：{"demandCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取终端流向详情中信息
result = json.loads(result.content)
# print(result)
result = {"demandCode": result["data"]["list"][0]["demandCode"]}
# 将接口响应时间添加至结果中
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict61", demand_code)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
