# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc导出功能验证_客户采购计划,2295,2295-81,sit,bs
主数据平台:后台运营系统客户采购计划导出接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import random
import requests
import json
import os

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取客户采购计划列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url79")
request_body = commonFuc().get_business_data(module, "payload79")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
pro_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取客户采购计划信息
customerInfo = result["data"]["list"][pro_random]["customerCode"]

# 第三步进行客户采购计划导出操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url81")
request_body = commonFuc().get_business_data(module, "payload81", customerInfo)

"""

 场景: 导出功能验证_客户采购计划
 用例名称：导出功能验证_客户采购计划
 输出：{"customerCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/采购计划汇总导出.xlsx"

# 获取到导出文件存入cmdc_files文件中
with open(file_path, 'wb') as f:
    f.write(result.content)

# 获取导出文件中客户编码
excel = HandleExcel(file_path, "Sheet1")
# print(excel.read_data())
result = {"customerCode": excel.read_data()[0].get("客户编码")}

# 将接口响应时间添加至结果中
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict81", customerInfo)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
