# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_客户列表_代客下单,2295,2295-34,sit,bs
主数据平台:后台运营系统获取客户信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取客户信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url33")
request_body = commonFuc().get_business_data(module, "payload33")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
customer_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取客户信息
telephone = result["data"]["list"][customer_random]["telephone"]
user_no = result["data"]["list"][customer_random]["userNo"]
user_name = result["data"]["list"][customer_random]["userName"]
customer_company_name = result["data"]["list"][customer_random]["customerCompanyName"]

# 第三步进行条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url34")
request_body = commonFuc().get_business_data(module, "payload34", telephone, user_no, user_name, customer_company_name)

"""
 场景: 查询条件验证_客户列表_代客下单
 用例名称：查询条件验证_客户列表_代客下单
 输出：{"userNo":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取查询结果中客户信息
result = json.loads(result.content)
result = {"userNo": result["data"]["list"][0]["userNo"]}
# 将接口响应时间添加至结果中
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict34", user_no)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
