# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc查询条件验证_草稿列表_代客下单,2295,2295-52,sit,bs
主数据平台:后台运营系统获取草稿列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取草稿列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url51")
request_body = commonFuc().get_business_data(module, "payload51")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
user_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取草稿信息
user_name = result["data"]["list"][user_random]["userName"]
user_no = result["data"]["list"][user_random]["userNo"]
start_time = result["data"]["list"][user_random]["createTime"][:10]
end_time = datetime.datetime.now().strftime("%Y-%m-%d")

# 第三步进行查询条件验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url52")
request_body = commonFuc().get_business_data(module, "payload52", user_name, user_no, start_time, end_time)

"""
 场景: 查询条件验证_草稿列表_代客下单
 用例名称：查询条件验证_草稿列表_代客下单
 输出：{"userNo":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取查询结果中客户信息
result = json.loads(result.content)
result = {"userNo": result["data"]["list"][0]["userNo"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict52", user_no)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
