# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_三方用户列表,2271,2271-35,sit,bs
主数据平台:后台运营系统三方用户信息查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取三方用户信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url31")
request_body = commonFuc().get_business_data(module, "payload31")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字，用于后续随机选择三方用户信息
user_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取三方用户信息
customer_name = result["data"]["list"][user_random]["customerName"]
customer_code = result["data"]["list"][user_random]["customerCode"]

# 第三步进行三方用户信息查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url32")
request_body = commonFuc().get_business_data(module, "payload32", customer_name, customer_code)

"""
 场景: 列表查询条件验证_三方用户列表
 用例名称：列表查询条件验证_三方用户列表
 输出：{"customerCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
# print(result)
# 获取查询结果中三方用户信息
result = {"customerCode": result["data"]["list"][0]["customerCode"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict32", customer_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
