# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc特价单品_限购验证,2252,2252-73,sit,bs
涉及到接口:特价单品列表查询、splitGroup等接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json

module = "cmdc_special_fresenius_group"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步特价单品查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload40")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取商品信息
fresenius_price_id = result["data"]["list"][0]["freseniusPriceId"]

# 第三步进行限购验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url42")
request_body = commonFuc().get_business_data(module, "payload42", fresenius_price_id)

"""

 场景: 特价单品限购验证
 用例名称：特价单品限购验证
 输出：{"purchaseQuantity":5"}
"""

# 发送请求
result = requests.get(url, params=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

result = json.loads(result.content)

result["api_time"] = api_time

# 进行相应判断，当success为true时，说明超限额，否则未超限额
if result["success"]:
    # 获取结果中限购数量
    result = {"purchaseQuantity": result["data"]["purchaseQuantity"]}
    result["api_time"] = api_time
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict42")
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    print(result)
