# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc产品线已存在_植入产品线新增,00,00-47,sit,be
主数据平台:后台运营系统植入产品线新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_admin2")
password = commonFuc().get_business_data(module, "password_admin2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取植入产品线列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url45")
request_body = commonFuc().get_business_data(module, "payload45")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取产品线信息
productLineCode = result["data"]["list"][0]["productLineCode"]
productLineName = result["data"]["list"][0]["productLineName"]
numberSource = result["data"]["list"][0]["numberSource"]
soStartTimeStr = result["data"]["list"][0]["soStartTimeStr"]
# 第三步植入产品线新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url47")
request_body = [
    commonFuc().get_business_data(module, "payload47", productLineCode, productLineName, numberSource, soStartTimeStr)]

"""

 场景: 产品线已存在_植入产品线新增
 用例名称：产品线已存在_植入产品线新增
 输出：{"errList":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取新增产品线信息
result = json.loads(result.content)
# print(result)
result = {"errList": result["data"]["errList"][0]}

# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict47", productLineName)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
