# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_待处理需求单列表_待审核,00,00-4,sit,be
主数据平台:后台运营系统获取需求单列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取需求单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url2")
request_body = commonFuc().get_business_data(module, "payload2")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
demand_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取需求单信息
demandParentCode = result["data"]["list"][demand_random]["demandParentCode"]
orderSource = result["data"]["list"][demand_random]["orderSource"]
customerName = result["data"]["list"][demand_random]["customerName"]
loginName = result["data"]["list"][demand_random]["loginName"]
customerCode = result["data"]["list"][demand_random]["customerCode"]
productLineName = (result["data"]["list"][demand_random]["productLineName"] if result["data"]["list"][demand_random][
    "productLineName"] else "")
manufacturer = ""
productName = (result["data"]["list"][demand_random]["productName"] if result["data"]["list"][demand_random][
    "productName"] else "")
listOrderStatus = result["data"]["list"][demand_random]["orderStatus"]
tempListOrderStatus = listOrderStatus
productCode = (result["data"]["list"][demand_random]["productCode"] if result["data"]["list"][demand_random][
    "productCode"] else "")
startTime = result["data"]["list"][demand_random]["createTime"][:10]
endTime = datetime.datetime.now().strftime("%Y-%m-%d")
distributionType = result["data"]["list"][demand_random]["distributionType"]

# 第三步进行列表条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url4")
request_body = commonFuc().get_business_data(module, "payload4", demandParentCode, orderSource, customerName, loginName,
                                             customerCode, productLineName, manufacturer, productName, listOrderStatus,
                                             tempListOrderStatus, productCode, startTime, endTime, distributionType)

# print(request_body)
"""

 场景: 列表查询条件验证_待处理需求单列表_待审核
 用例名称：列表查询条件验证_待处理需求单列表_待审核
 输出：{"demandParentCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取需求单列表中待审核需求单数量
result = json.loads(result.content)
result = {"demandParentCode": result["data"]["list"][0]["demandParentCode"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict4", demandParentCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
