# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取原始需求单信息_三方需求单,00,00-25,sit,be
主数据平台:后台运营系统获取原始需求单信息接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_special_version"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username_do_be")
password = commonFuc().get_business_data(module, "password_do_be")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取需求单列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
demand_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取三方需求单信息
demandCode = result["data"]["list"][demand_random]["demandCode"]

# 第三步进行列表条件查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url25")
request_body = commonFuc().get_business_data(module, "payload25", demandCode)
"""

 场景: 获取原始需求单信息_三方需求单
 用例名称：获取原始需求单信息_三方需求单
 输出：{"demandCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取需求单信息
result = json.loads(result.content)
result = {"demandCode": result["data"]["demandSkuList"]["list"][0]["demandCode"]}
# 将接口响应时间添加至result
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict25", demandCode)
# print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
